Doomsday Engine - Bug #788

Momentary pause during looped MIDI playback
2009-09-27 03:32 - danij

Status: Closed Start date: 2009-09-27
Priority: Normal % Done: 100%
Assignee: Deng Team

Category: Defect

Target version: 1.13.1

Description

During the title loops of all games, a short music piece is played non-looped at the beginning of the sequence (called from InFine).
Each time this occurs, if the title music is in MUS format; there is a momentary pause while the engine performs MUS to MIDI
conversion (the title music is quite a short piece so the delay isn't a major problem).

For Doomsday 2.0 we should consider implementing a universal resource caching mechanism which could be utilized for this.

Related issues:
Related to Feature #1692: [Windows] Upgrade SDL / SDL_mixer Closed 2013-12-30

History

#1 - 2009-09-27 07:19 - sonicdoommario

| don't think this is exclusive to the title screen though. When a MIDI stops playing, there is a brief pause, even though in Doom, any MIDI immediately
starts after it stops playing.

The best example of this is the story text music from TNT. In TNT, the story text MIDI is like 5 seconds long, so you hear the annoying pause every
few seconds, when it is supposed to loop without a pause right when the song ends.

#2 - 2009-10-02 07:49 - danij

No, its not exclusive to the titlescreen. The pause occurs any time the current music track is changed or reloaded. It would be interesting to see if it
occurs with the dsWinMM plugin because SDL_mixer basically wraps the same API, if they are both affected when playing MIDI music then we know
SDL_mixer is not to blame (leaving the Windows Multimedia APl and Doomsday's management of MIDI music as possible causes).

#3 - 2009-10-02 16:42 - danij

If however the problem is also affecting OS X then | think we can safely say that its the handling of MIDI files (i.e., the MUS to MIDI conversion) in
Doomsday to blame.

#4 - 2009-10-02 16:43 - danij
According to what I've read recently in numerous places across the net this is a known issue with SDL_mixer.

The changelog for SDL_mixer 1.2.9 states "Implemented seamless looping for music playback" but after updating to the latest version 1.2.11, the
pausing problem persists for me on Windows. Now that | think about it, they were probably referring to non-MIDI playback.

#5 - 2009-11-07 10:15 - skyjake

Somehow | doubt the conversion is the problem here: after all, it simply loops through the MUS events and converts them to corresponding MIDI
events (plus it's a short song).

Let's re-evaluate the situation after we have FMOD in use.

#6 - 2009-11-18 02:13 - danij

Upped the priority of this because this issue quickly becomes exceedingly annoying, especially on maps with very short MIDls.

#7 - 2009-11-18 02:51 - skyjake
Is this an issue any more with the revised dsFMOD (and dsFluidSynth) plugins?

#8 - 2012-08-28 17:24 - danij

Still occurs for me in Windows, using the latest build 604 and the FMOD audio driver for all interfaces.

#9 - 2013-10-18 13:52 - skyjake
- Tags set to Music, Audio, Windows

- Description updated

#10 - 2013-10-22 17:40 - skyjake
- Category set to Defect
- Target version deleted (1.9.0-beta6)

#11 - 2014-01-04 13:17 - skyjake
This should be re-tested now that SDL has been upgraded.

#12 - 2014-01-06 00:31 - sonicdoommario

Gave the new 1.13.1 release a shot, and this seems to be working great with the new SDL. Tried out a short MIDI, like the TNT story music, and
never had any problems with playback, looped immediately.

#13 - 2014-01-06 06:11 - skyjake

- Status changed from New to Closed
- Assignee set to Deng Team

- Target version set to 1.13.1

- % Done changed from 0 to 100
